// Copyright (c) 2009 Steve Gribble.
//
// Tests for linked_list.[c\h]

#include <stdio.h>
#include <assert.h>
#include "linked_list.h"

int main(int argc, char **argv) {
  linked_list_t list;

  // test create and destroy
  list = linked_list_create();
  assert(list != NULL);
  assert(is_list_empty(list));
  linked_list_destroy(list);
  
  // test adds/gets/removes
  list = linked_list_create();
  assert(list != NULL);
  assert(is_list_empty(list));

  assert(linked_list_add_to_front(list, (list_element_t) 0));
  assert(!is_list_empty(list));
  linked_list_remove_from_front(list);
  assert(is_list_empty(list));

  assert(linked_list_add_to_back(list, (list_element_t) 1));
  assert(linked_list_add_to_front(list, (list_element_t) 2));
  assert(linked_list_add_to_back(list, (list_element_t) 3));
  assert(!is_list_empty(list));
  assert(((int) linked_list_front(list)) == 2);
  assert(((int) linked_list_back(list)) == 3);

  linked_list_remove_from_back(list);
  assert(!is_list_empty(list));
  assert(((int) linked_list_front(list)) == 2);
  assert(((int) linked_list_back(list)) == 1);

  linked_list_remove_from_front(list);
  assert(!is_list_empty(list));
  assert(((int) linked_list_front(list)) == 1);
  assert(((int) linked_list_back(list)) == 1);

  linked_list_remove_from_back(list);
  assert(is_list_empty(list));

  linked_list_destroy(list);
  return 0;
}
